using System;
using TclInterop;

namespace tclskript
{
	/// <summary>
	/// Zusammenfassung fr Customer.
	/// </summary>
	public class Customer
	{
		private string _name = "John Test";
		private int _age = 34;
		private DateTime _lastOrderTime = new DateTime(1997,09,07);
		public string annotation;
		public string Name 
		{
			get { return _name;}
			set { _name = value;}
		}
		public int Age
		{
			get { return _age;}
			set { _age = value;}
		}
		public DateTime LastOrderTime
		{
			get { return _lastOrderTime;}
		}
		public void order() 
		{
			_lastOrderTime = DateTime.Now;
		}
		/// <summary>
		/// Test for static methods
		/// </summary>
		/// <returns></returns>
		[TclMethod("customerVersion")]
		public static string getVersion()  
		{
			return "1.02.23";
		}		
	}
}
