using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using TclInterop;

namespace tclskript
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class TclEvalView : System.Windows.Forms.Form
	{
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button txtScript;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.Label labCustName;
		private System.Windows.Forms.Label labAge;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtAnnotation;
		public  TclInterpreter interpreter;
		private System.Windows.Forms.TextBox txtCustName;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.NumericUpDown numAge;
		private System.Windows.Forms.DateTimePicker dateOrder;
		public Customer customer;

		public TclEvalView()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
			interpreter = new TclInterpreter();
			interpreter.setObjectInterop();
			customer = new Customer();
			textBox1.Text = "# evaluate this script below. \r\n# push the button Evaluate Tcl Script \r\nreturn \"welcome $env(USERNAME) in Tcl world\"";
			textBox1.Select(0,0);
			refreshCustomerView();
			registerCallback(this,EventArgs.Empty); 
			registerCustomer(this,EventArgs.Empty); 
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.txtScript = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.txtCustName = new System.Windows.Forms.TextBox();
			this.labCustName = new System.Windows.Forms.Label();
			this.labAge = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.txtAnnotation = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.numAge = new System.Windows.Forms.NumericUpDown();
			this.dateOrder = new System.Windows.Forms.DateTimePicker();
			this.panel1.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numAge)).BeginInit();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.ContextMenu = this.contextMenu1;
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Location = new System.Drawing.Point(0, 23);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(384, 369);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem1,
																						 this.menuItem7,
																						 this.menuItem5});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Shortcut = System.Windows.Forms.Shortcut.CtrlQ;
			this.menuItem1.Text = "Eval Selection";
			this.menuItem1.Click += new System.EventHandler(this.evalSeceltion);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 1;
			this.menuItem7.Text = "Eval All Text";
			this.menuItem7.Click += new System.EventHandler(this.evalSkript);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 2;
			this.menuItem5.Shortcut = System.Windows.Forms.Shortcut.CtrlE;
			this.menuItem5.Text = "Show errorInfo";
			this.menuItem5.Click += new System.EventHandler(this.showErrorInfo);
			// 
			// txtScript
			// 
			this.txtScript.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.txtScript.Location = new System.Drawing.Point(0, 490);
			this.txtScript.Name = "txtScript";
			this.txtScript.Size = new System.Drawing.Size(384, 23);
			this.txtScript.TabIndex = 1;
			this.txtScript.Text = "Eval Tcl Script";
			this.txtScript.Click += new System.EventHandler(this.evalSkript);
			// 
			// textBox2
			// 
			this.textBox2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.textBox2.Location = new System.Drawing.Point(0, 410);
			this.textBox2.Multiline = true;
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(384, 80);
			this.textBox2.TabIndex = 2;
			this.textBox2.Text = "";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2});
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4,
																					  this.menuItem6,
																					  this.menuItem3});
			this.menuItem2.Text = "Tcl Examples";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "Pure Tcl";
			this.menuItem4.Click += new System.EventHandler(this.exampleSingleTcl);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 1;
			this.menuItem6.Text = "Simple Callbacks to NET";
			this.menuItem6.Click += new System.EventHandler(this.exampleNetCallback);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.Text = "Object automation form Tcl";
			this.menuItem3.Click += new System.EventHandler(this.exampleObjectInterop);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.Controls.Add(this.splitter1);
			this.panel1.Controls.Add(this.textBox1);
			this.panel1.Controls.Add(this.label4);
			this.panel1.Controls.Add(this.textBox2);
			this.panel1.Controls.Add(this.txtScript);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(384, 513);
			this.panel1.TabIndex = 4;
			// 
			// splitter1
			// 
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.splitter1.Cursor = System.Windows.Forms.Cursors.HSplit;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 384);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(384, 8);
			this.splitter1.TabIndex = 3;
			this.splitter1.TabStop = false;
			// 
			// label4
			// 
			this.label4.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.label4.Location = new System.Drawing.Point(0, 392);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(384, 18);
			this.label4.TabIndex = 5;
			this.label4.Text = "Tcl Script Result";
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Location = new System.Drawing.Point(0, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(384, 23);
			this.label1.TabIndex = 4;
			this.label1.Text = "Tcl Evaluation Area - use popup menu";
			// 
			// txtCustName
			// 
			this.txtCustName.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.txtCustName.Location = new System.Drawing.Point(128, 24);
			this.txtCustName.Name = "txtCustName";
			this.txtCustName.Size = new System.Drawing.Size(128, 20);
			this.txtCustName.TabIndex = 5;
			this.txtCustName.Text = "";
			this.txtCustName.TextChanged += new System.EventHandler(this.nameChanged);
			// 
			// labCustName
			// 
			this.labCustName.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labCustName.Location = new System.Drawing.Point(16, 24);
			this.labCustName.Name = "labCustName";
			this.labCustName.TabIndex = 6;
			this.labCustName.Text = "Cust. Name";
			// 
			// labAge
			// 
			this.labAge.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labAge.Location = new System.Drawing.Point(16, 48);
			this.labAge.Name = "labAge";
			this.labAge.TabIndex = 8;
			this.labAge.Text = "Age";
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label2.Location = new System.Drawing.Point(16, 80);
			this.label2.Name = "label2";
			this.label2.TabIndex = 10;
			this.label2.Text = "Last Order Time";
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label3.Location = new System.Drawing.Point(16, 136);
			this.label3.Name = "label3";
			this.label3.TabIndex = 12;
			this.label3.Text = "Annotation";
			// 
			// txtAnnotation
			// 
			this.txtAnnotation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.txtAnnotation.Location = new System.Drawing.Point(16, 160);
			this.txtAnnotation.Multiline = true;
			this.txtAnnotation.Name = "txtAnnotation";
			this.txtAnnotation.Size = new System.Drawing.Size(240, 120);
			this.txtAnnotation.TabIndex = 11;
			this.txtAnnotation.Text = "";
			this.txtAnnotation.TextChanged += new System.EventHandler(this.annotationChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.dateOrder);
			this.groupBox1.Controls.Add(this.numAge);
			this.groupBox1.Controls.Add(this.txtAnnotation);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.labAge);
			this.groupBox1.Controls.Add(this.labCustName);
			this.groupBox1.Controls.Add(this.txtCustName);
			this.groupBox1.Location = new System.Drawing.Point(392, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(280, 304);
			this.groupBox1.TabIndex = 13;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Sample Object View (customer)";
			// 
			// numAge
			// 
			this.numAge.Location = new System.Drawing.Point(128, 48);
			this.numAge.Name = "numAge";
			this.numAge.Size = new System.Drawing.Size(128, 20);
			this.numAge.TabIndex = 13;
			this.numAge.ValueChanged += new System.EventHandler(this.ageChanged);
			// 
			// dateOrder
			// 
			this.dateOrder.Enabled = false;
			this.dateOrder.Location = new System.Drawing.Point(16, 96);
			this.dateOrder.Name = "dateOrder";
			this.dateOrder.Size = new System.Drawing.Size(248, 20);
			this.dateOrder.TabIndex = 14;
			// 
			// TclEvalView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(680, 513);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.panel1);
			this.Menu = this.mainMenu1;
			this.Name = "TclEvalView";
			this.Text = "Tcl Eval";
			this.panel1.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numAge)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TclEvalView());
		}

		private void evalSeceltion(object sender, System.EventArgs e)
		{
			string selected = textBox1.SelectedText;
			if (selected.Length==0) return;
			evalString(selected);
		}
		private void evalSkript(object sender, System.EventArgs e)
		{
			if (textBox1.Text.Length==0) return;
			evalString(textBox1.Text);
		}
		private void evalString(string script) 
		{
			int ret = interpreter.evalScript(script);
			if (ret==0) 
			{
				string result = interpreter.Result;
				result = result.Replace("\n",Environment.NewLine);
				/*
				Clipboard.SetDataObject(result);
				int estart = textBox1.SelectionStart;
				textBox1.Select(estart,0);
				textBox1.Paste();
				*/
				textBox2.Text = (string)result.Clone();
			} 
			else 
			{
				// textBox2.Text = "Fehler";
				showErrorInfo(this,EventArgs.Empty);
			}
		}
		private void showErrorInfo(object sender, System.EventArgs e) 
		{
			if (interpreter.evalScript("set errorInfo")==0) {
				string result = interpreter.Result;
				result = result.Replace("\n",Environment.NewLine);
				textBox2.Text = result;
			}
		}
		private void registerViewObject(object sender, System.EventArgs e) 
		{
			interpreter.setObjectInterop();
			interpreter.registerObject(this,"view");
		}
		private void registerCallback(object sender, System.EventArgs e) 
		{
			interpreter.registerTclCommand("winform",this,this.GetType().GetMethod("popMessageBox"));
			interpreter.registerTclCommand("winparam",this,this.GetType().GetMethod("popMessageBoxParam"));
		}
		private void registerCustomer(object sender, System.EventArgs e) 
		{
			interpreter.registerTclCommandsInObject(this);
			interpreter.registerTclCommandsForType(typeof(Customer));
			interpreter.registerObject(this.customer,"customer");
		}
		public void popMessageBox() 
		{
			MessageBox.Show("Callback from Tcl recived!");
		}
		public void popMessageBoxParam(int param) 
		{
			MessageBox.Show("Callback with int parameter from Tcl recived! " + param.ToString());
		}
		[TclMethod("showMessage")]
		public void showMessage (string message) 
		{
			MessageBox.Show(message);
		}
		/// <summary>
		/// This method will be registered automitic as tcl procedure with name
		/// refreshView
		/// </summary>
		[TclMethod("refreshView")]
		public void refreshCustomerView() 
		{
			txtCustName.Text = customer.Name;
			numAge.Value = (decimal)customer.Age;
			dateOrder.Value = customer.LastOrderTime;
			txtAnnotation.Text = customer.annotation;
		}
		public void ageChanged(object sender, System.EventArgs e) 
		{
			customer.Age = (int)numAge.Value;
		}
		public void dateChanged(object sender, System.EventArgs e) 
		{
			// customer.LastOrderTime = dateOrder.Value;
		}
		public void nameChanged(object sender, System.EventArgs e) 
		{
			customer.Name = txtCustName.Text;
		}
		public void annotationChanged(object sender, System.EventArgs e) 
		{
			customer.annotation = txtAnnotation.Text;
		}
		#region examples
		private void exampleSingleTcl(object sender, System.EventArgs e) 
		{
			textBox1.Text = @"# This is pure tcl example
# first define one proc
# return random element from List
proc randomElem list {
    set pos [expr {int(rand()*[llength $list])}]
    return [lindex $list $pos]
}
set favorite [randomElem {C# Java VB Smalltalk Tcl}]
return ""I want to program $favorite""
";
			textBox1.Select(0,0);
		}
		private void exampleNetCallback(object sender, System.EventArgs e) 
		{
			textBox1.Text = @"#same method in NET was registered as 
#newTcl procedure
# next 2 procedures in viewed form (see source)
winform; # invoke public void popMessageBox() 
winparam 47; # invoke public void popMessageBoxParam(int param) 
customerVersion; # invoke static method in NET class Customer 
";
			textBox1.Select(0,0);
		}
		private void exampleObjectInterop(object sender, System.EventArgs e) 
		{
			textBox1.Text = @"# cusomer object was registered in tcl interop
# methods, fild and properties can be restrospected and changed
showMessage ""Introspected available properties: [objinfo customer properties]""
showMessage ""Type of property Age: [objinfo customer propertytype Age]""
# some action on customer object
objproperty customer Age 40
if {[objproperty customer Age]>20} {
   showMessage ""Customer is older than 20""
}
objproperty customer Name {Bill XOTcl}
objfield customer annotation ""This text was set from Tcl""
# invoke method public void order() in C#
objinvoke customer order
refreshView
return OK
";
			textBox1.Select(0,0);
		}
		#endregion examples
	}
}
